# coding: utf-8

"""
    Knowledge-Graph Create API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from deepsearch.cps.apis.kg.create.api_client import ApiClient
from deepsearch.cps.apis.kg.create.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class NodesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_nodes(self, categories, size, **kwargs):  # noqa: E501
        """create_nodes  # noqa: E501

        Creates a set of new nodes in the graph.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_nodes(categories, size, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param list[str] categories: Categories to which the newly created nodes belong (required)
        :param int size: number of nodes to be created (required)
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.create_nodes_with_http_info(categories, size, **kwargs)  # noqa: E501

    def create_nodes_with_http_info(self, categories, size, **kwargs):  # noqa: E501
        """create_nodes  # noqa: E501

        Creates a set of new nodes in the graph.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_nodes_with_http_info(categories, size, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param list[str] categories: Categories to which the newly created nodes belong (required)
        :param int size: number of nodes to be created (required)
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'categories',
            'size'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_nodes" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'categories' is set
        if self.api_client.client_side_validation and ('categories' not in local_var_params or  # noqa: E501
                                                        local_var_params['categories'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `categories` when calling `create_nodes`")  # noqa: E501
        # verify the required parameter 'size' is set
        if self.api_client.client_side_validation and ('size' not in local_var_params or  # noqa: E501
                                                        local_var_params['size'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `size` when calling `create_nodes`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'categories' in local_var_params and local_var_params['categories'] is not None:  # noqa: E501
            query_params.append(('categories', local_var_params['categories']))  # noqa: E501
            collection_formats['categories'] = 'csv'  # noqa: E501
        if 'size' in local_var_params and local_var_params['size'] is not None:  # noqa: E501
            query_params.append(('size', local_var_params['size']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/create', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ingest_nodes(self, rebuild_indices, nodes, **kwargs):  # noqa: E501
        """ingest_nodes  # noqa: E501

        Create a set of new nodes in the graph   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ingest_nodes(rebuild_indices, nodes, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str rebuild_indices: Rebuild the node lookup-indices after ingestion. (required)
        :param list[Node] nodes: Array of nodes (required)
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.ingest_nodes_with_http_info(rebuild_indices, nodes, **kwargs)  # noqa: E501

    def ingest_nodes_with_http_info(self, rebuild_indices, nodes, **kwargs):  # noqa: E501
        """ingest_nodes  # noqa: E501

        Create a set of new nodes in the graph   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ingest_nodes_with_http_info(rebuild_indices, nodes, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str rebuild_indices: Rebuild the node lookup-indices after ingestion. (required)
        :param list[Node] nodes: Array of nodes (required)
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'rebuild_indices',
            'nodes'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ingest_nodes" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'rebuild_indices' is set
        if self.api_client.client_side_validation and ('rebuild_indices' not in local_var_params or  # noqa: E501
                                                        local_var_params['rebuild_indices'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `rebuild_indices` when calling `ingest_nodes`")  # noqa: E501
        # verify the required parameter 'nodes' is set
        if self.api_client.client_side_validation and ('nodes' not in local_var_params or  # noqa: E501
                                                        local_var_params['nodes'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `nodes` when calling `ingest_nodes`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'rebuild_indices' in local_var_params and local_var_params['rebuild_indices'] is not None:  # noqa: E501
            query_params.append(('rebuildIndices', local_var_params['rebuild_indices']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'nodes' in local_var_params:
            body_params = local_var_params['nodes']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/ingest', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)

    def ingest_nodes_mongo(self, rebuild_indices, databases, **kwargs):  # noqa: E501
        """ingest_nodes_mongo  # noqa: E501

        Create a set of new nodes in the graph from a Mongo-DB  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ingest_nodes_mongo(rebuild_indices, databases, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str rebuild_indices: Rebuild the node lookup-indices after ingestion. (required)
        :param list[DatabaseSource] databases: Array of Mongo-databases/collections to ingest. (required)
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.ingest_nodes_mongo_with_http_info(rebuild_indices, databases, **kwargs)  # noqa: E501

    def ingest_nodes_mongo_with_http_info(self, rebuild_indices, databases, **kwargs):  # noqa: E501
        """ingest_nodes_mongo  # noqa: E501

        Create a set of new nodes in the graph from a Mongo-DB  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.ingest_nodes_mongo_with_http_info(rebuild_indices, databases, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str rebuild_indices: Rebuild the node lookup-indices after ingestion. (required)
        :param list[DatabaseSource] databases: Array of Mongo-databases/collections to ingest. (required)
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'rebuild_indices',
            'databases'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method ingest_nodes_mongo" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'rebuild_indices' is set
        if self.api_client.client_side_validation and ('rebuild_indices' not in local_var_params or  # noqa: E501
                                                        local_var_params['rebuild_indices'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `rebuild_indices` when calling `ingest_nodes_mongo`")  # noqa: E501
        # verify the required parameter 'databases' is set
        if self.api_client.client_side_validation and ('databases' not in local_var_params or  # noqa: E501
                                                        local_var_params['databases'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `databases` when calling `ingest_nodes_mongo`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'rebuild_indices' in local_var_params and local_var_params['rebuild_indices'] is not None:  # noqa: E501
            query_params.append(('rebuildIndices', local_var_params['rebuild_indices']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'databases' in local_var_params:
            body_params = local_var_params['databases']
        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/ingest/Mongo', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
